﻿package {
	
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.display.SimpleButton;
	import flash.display.GradientType;
	import flash.text.TextField;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	import flash.geom.Matrix;
	
	
	/**
	 * @author necoEngine bamboo-satellites
	 * @version 
	 * @see http://www.bamboo-satellites.com/
	 */
	public class ButtonCreater extends SimpleButton {
		
		private const FONT_SIZE:int  = 10;
		private const FONT_COLOR:int = 0x7A5B52
		private const PADDING_W:int  = 20;
		private const PADDING_H:int  = 6;
		
		private const DOWN_HIGHLIGHT:int = 0xFFFFFF;
		private const UP_HIGHLIGHT:int   = 0xFFFFCC;
		private const OVER_HIGHLIGHT:int = 0xFFFFCC;
		private const DOWN_SHADOW:int = 0xFFFF99;
		private const UP_SHADOW:int   = 0xFF9900;
		private const OVER_SHADOW:int = 0xFFCC66;
		private const RECT_ANGLE:int = 14;
		
		
		public function ButtonCreater(str:String = ""):void {
			
			upState      = buttonStructure(str, UP_HIGHLIGHT,   UP_SHADOW);
			downState    = buttonStructure(str, DOWN_HIGHLIGHT, DOWN_SHADOW);
			overState    = buttonStructure(str, OVER_HIGHLIGHT, OVER_SHADOW);
			hitTestState = buttonStructure(str, OVER_HIGHLIGHT, OVER_SHADOW);
			
		} // constructor close
		
		
		private function buttonStructure(str:String, highLight:uint, shadow:uint):Sprite {
			
			var sp:Sprite         = new Sprite();
			var tf:TextField      = new TextField();
			var format:TextFormat = new TextFormat();
			
			//TextFormat
			format.color = FONT_COLOR;
			format.size  = FONT_SIZE;
			format.font  = "Verdana";
			format.bold  = true;
			format.align = TextFormatAlign.CENTER;
			format.letterSpacing = -0.5;
			
			//TextField
			tf.defaultTextFormat = format;
			tf.text = str;
			
			tf.type   = TextFieldType.DYNAMIC;
			tf.width  = tf.textWidth  + PADDING_W;
			tf.height = tf.textHeight + PADDING_H;
			tf.x = 0;
			tf.y = 1;
			tf.selectable = false;
			
			//ボタン背景描画
			var gColor:Array   = [highLight, shadow];
			var gAlpha:Array   = [1, 1];
			var gRatio:Array   = [0, 255];
			var gMatrix:Matrix = new Matrix();
			gMatrix.createGradientBox(tf.textWidth + PADDING_W, tf.textHeight + PADDING_H, Math.PI / 2);
			
			sp.graphics.lineStyle(1, 0xAAAAAA, 1, true);
			sp.graphics.beginGradientFill(GradientType.LINEAR, gColor, gAlpha, gRatio, gMatrix);
			sp.graphics.drawRoundRect(0, 0, tf.textWidth + PADDING_W, tf.textHeight + PADDING_H, RECT_ANGLE);
			sp.graphics.endFill();
			
			sp.addChild(tf);
			
			return sp;
			
		} // buttonStructure() close
	}
}